package it.amattioli.guidate.containers;

import it.amattioli.applicate.commands.ApplicationException;
import it.amattioli.applicate.commands.Command;
import it.amattioli.guidate.util.CustomMessagebox;
import it.amattioli.guidate.util.DesktopAttributes;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.Events;

import static it.amattioli.guidate.validators.ValidatingComposer.ON_VALIDATE_ELEMENT;

public class CommandComposer extends BackBeanComposer {
	private static final Logger logger = LoggerFactory.getLogger(CommandComposer.class);

    @Override
    public void doAfterCompose(Component comp) throws Exception {
    	super.doAfterCompose(comp);
    }
    
    public void onDoCommand(Event evt) throws Exception {
    	Component comp = evt.getTarget();
    	Command command = (Command)BackBeans.findBackBean(comp);
    	Events.sendEvent(new Event(ON_VALIDATE_ELEMENT, comp));
    	try {
    		DesktopAttributes.getSession(comp).execute(command);
            afterCommand();
        } catch(ApplicationException e) {
        	logger.error("Error", e);
            CustomMessagebox.show(e);
            Events.postEvent(new Event(Events.ON_CLOSE, self));
        }
    }

	protected void afterCommand() {
		Events.postEvent(new Event(Events.ON_CLOSE, self));
	}
    
    public void onCancelCommand(Event evt) {
    	Component comp = evt.getTarget();
    	Command command = (Command)BackBeans.findBackBean(comp);
        command.cancelCommand();
        afterCommand();
    }
    
    public void onApplyCommand(Event evt) throws Exception {
    	Component comp = evt.getTarget();
    	Command command = (Command)BackBeans.findBackBean(comp);
    	Events.sendEvent(new Event(ON_VALIDATE_ELEMENT, comp));
    	try {
    		command.doCommand();
        } catch(ApplicationException e) {
        	logger.error("Error", e);
            CustomMessagebox.show(e);
            Events.postEvent(new Event(Events.ON_CLOSE, self));
        }
    }

}
